clear all
set more off

cd "O:\mentalhealth\data\"


**------------------------------------------------------------------------------*
** GP and ER cons., spec categories **
*------------------------------------------------------------------------------*
forvalues i = 2006/2021      {

	use "S:/Project/DemoSos2/data2020/KUHR2021/KUHR`i'", clear
	drop if lopenr == ""
	 
	rename (Diagnose BehandlerID BehKnr BehPostnr Refusjon Alder Tid kjonn) (diagnose docid gpmun gppostcode reimburse age hour gender)
		
	ge simple_contact = regexm(Takst, "1ADx") | regexm(Takst, "1AKx") | regexm(Takst, "1BDx") | regexm(Takst, "1BKx") | regexm(Takst, "1Ex") | regexm(Takst, "1Fx") | regexm(Takst, "1Gx") | regexm(Takst, "1Hx") | regexm(Takst, "1Ix")  
	
	ge simple_inperson = regexm(Takst, "1ADx") | regexm(Takst, "1AKx") | regexm(Takst, "1BDx") | regexm(Takst, "1BKx") | regexm(Takst, "1Ex") 
	
	ge simple_nopinperson = regexm(Takst, "1Fx") | regexm(Takst, "1Gx") | regexm(Takst, "1Hx") | regexm(Takst, "1Ix")   
	
	ge consult =  regexm(Takst, "2ADx") | regexm(Takst, "2AEx") | regexm(Takst, "2AKx") | regexm(Takst, "2BDx") | regexm(Takst, "2CDx") | regexm(Takst, "2CKx") | regexm(Takst, "2DDx") | regexm(Takst, "2DKx") | regexm(Takst, "2HDx") | regexm(Takst, "2LDx") | regexm(Takst, "2Px") | regexm(Takst, "2KNx") 
	
	ge sick_visit  = regexm(Takst, "11") | regexm(Takst, "14") | regexm(Takst, "15") 
	
	ge procedure =(regexm(Takst, "100") | regexm(Takst, "101") | regexm(Takst, "102") | regexm(Takst, "103") | regexm(Takst, "104") | regexm(Takst, "105") | regexm(Takst, "106") | regexm(Takst, "107") | regexm(Takst, "108")| regexm(Takst, "109") | regexm(Takst, "110") | regexm(Takst, "111")) 
	
	ge life_style_adv = regexm(Takst, "101") | regexm(Takst, "102")
	
	ge major_surg = regexm(Takst, "105") | regexm(Takst, "106")
	
	ge gy_exam =  regexm(Takst, "103b") | regexm(Takst, "104") |  regexm(Takst, "214")  | regexm(Takst, "215") | regexm(Takst, "217")
	
	ge ultra_sound = regexm(Takst, "108") 
	
	ge blood_test = regexm(Takst, "1Ex")
	
	ge labtest = (regexm(Takst, "701") | regexm(Takst, "702") | regexm(Takst, "703") | regexm(Takst, "704") | regexm(Takst, "705") | regexm(Takst, "706") | regexm(Takst, "707") | regexm(Takst, "708") | regexm(Takst, "709")| regexm(Takst, "710") | regexm(Takst, "711") | regexm(Takst, "712")) 
	
	ge spec = regexm(Takst, "3ADx") | regexm(Takst, "3BDx") | regexm(Takst, "3Cx")|regexm(Takst, "4Ax") | regexm(Takst, "3Bx") | regexm(Takst, "3Cx")| regexm(Takst, "4Ax")| regexm(Takst, "4Bx")| regexm(Takst, "4Cx")| regexm(Takst, "4Dx")            
		
	ge small_procedure =regexm(Takst, "100") | regexm(Takst, "101") | regexm(Takst, "102") | regexm(Takst, "103") | regexm(Takst, "104") 
	
	ge large_procedure = regexm(Takst, "105") | regexm(Takst, "106") | regexm(Takst, "107") | regexm(Takst, "108")| regexm(Takst, "109") | regexm(Takst, "110") | regexm(Takst, "111") 
	
	ge appointment = simple_contact == 1 | consult==1 
	
 
	**  Count number of GP cons., ER cons., and number of sick notes each year -->>> this is not a correct variable (seems incomplete from takst handbook)
	ge sl = (regexm(Takst, "L1x1")) 

	*-----------------------------------------------------------------------------*
	** Psych. symp. and diag.
	* Psych. all
	ge psych = (regexm(diagnose , "P")) if TypeDiag == "ICPC-2"
	ge sl_p = (regexm(Takst, "L1x1")) if psych==1

	* Psych symptoms (P00-P29)
	ge ps = (regexm(diagnose , "P0")|regexm(diagnose , "P1")|regexm(diagnose , "P2")) if TypeDiag == "ICPC-2"
	* Psych. diagnoses (P70-P99)
	ge pd = (regexm(diagnose, "P7")|regexm(diagnose, "P8")|regexm(diagnose, "P9")) if TypeDiag == "ICPC-2"
	
	*diagnoses
	foreach x in A B D E F H K L N P R S T U W X Y Z {				
		ge diag_`x' = (regexm(diagnose , "`x'")) if TypeDiag == "ICPC-2"
	}
	
	foreach x in P0 P1 P2 P7 P8 P9 {
			ge psyc_`x' = (regexm(diagnose , "`x'")) if TypeDiag == "ICPC-2"
	}
	
	ge depression =  (regexm(diagnose , "P03")|regexm(diagnose , "P76")|regexm(diagnose , "P77")) if TypeDiag == "ICPC-2"
	ge anxiety =  (regexm(diagnose , "P01")|regexm(diagnose , "P02")|regexm(diagnose , "P06")|regexm(diagnose , "P74")) if TypeDiag == "ICPC-2"
	ge substance = (regexm(diagnose , "P15")|regexm(diagnose , "P16")|regexm(diagnose , "P17")|regexm(diagnose , "P18")|regexm(diagnose , "P19")) if TypeDiag == "ICPC-2"
	ge other_psy =  psych == 1 & depression!=1 & anxiety!=1 & substance !=1  & TypeDiag == "ICPC-2"
	*-----------------------------------------------------------------------------*
	** Rest category: All other diag.
	ge rest = psych!=1 & TypeDiag == "ICPC-2"
	ge gp_notpreg =  diag_W!=1 & TypeDiag == "ICPC-2"
	
	ge contracep = (regexm(diagnose , "W10")|regexm(diagnose , "W11")|regexm(diagnose , "W12")|regexm(diagnose ,"W13")|regexm(diagnose,"W14")) if diag_W==1 & TypeDiag == "ICPC-2"
	
	ge preg = (regexm(diagnose, "W78")|regexm(diagnose, "W79")|regexm(diagnose, "W80")|regexm(diagnose, "W81")|regexm(diagnose, "W82")|regexm(diagnose, "W83")|regexm(diagnose, "W84")|regexm(diagnose, "W85")|regexm(diagnose, "W90")|regexm(diagnose, "W91")|regexm(diagnose, "W92")|regexm(diagnose, "W93")|regexm(diagnose, "W94")|regexm(diagnose, "W95")|regexm(diagnose, "W96")|regexm(diagnose, "W99")) if diag_W==1 & TypeDiag == "ICPC-2"
	ge gest_diabetes = regexm(diagnose, "W85")
	
	ge preg_other = contracep!=1 & preg!=1 if diag_W==1 & TypeDiag == "ICPC-2"
	
	ge gest_hypertension = regexm(diagnose, "K86") |regexm(diagnose, "K87") if diag_W==1 & TypeDiag == "ICPC-2"
	
	ge icd10_l = substr(diagnose,1,1) if TypeDiag == "ICD-10"
	ge icd10_2 = substr(diagnose,2,2) if TypeDiag == "ICD-10"
	
	destring reimburse, replace dpcomma
	
	ge year = year(KUHRDato)
	ge month = month(KUHRDato)
	qui compress
	save "kurhgp_new_`i'.dta", replace
}
