clear all
set more off

cd "O:\mentalhealth\data\"



*------------------------------------------------------------------------------*
** SOMATIC **
*------------------------------------------------------------------------------*
foreach num of numlist  2008/2014 {
	use "S:/Project/DemoSos2/data2020/NPR/SOM/somatikk`num'.dta", clear
	destring _all, replace
	drop if lopenr == ""

	* Diagnoses:
	ge icd_l = substr(hoved1,1,1)
	drop hoved2
	*ge icd_l2 = substr(hoved2,1,1)
	*tab1 icd_l icd_l2
	replace icd_l = "" if icd_l == "9"
	*tab1 icd_l icd_l2

	tab  behandlingsniva3, m
	* Da blir outpatient kun poliklinikk
	gen admtype = 1 if behandlingsniva3 == 1 | behandlingsniva3 == 2
	replace admtype = 2 if behandlingsniva3 == 3
	lab var admtype "1 = inpatient (døgn+dagbeh.); 2 = outpatient (poliklinikk)"

	*** Indikatorer for i registeret (at all/inpatient/outpatient)
	ge npr = 1
	* split scheduled adm in in- and outpatient groups
	ge npr_in = 1 if admtype == 1 & innmatehast == 2
	ge npr_out = 1 if admtype == 2 & innmatehast == 2
	* Emergency adm
	ge npr_er= 1 if innmatehast == 1

	*** Ekskluderer preg. related stuff
	* Alle O'er er svangerskap etc
	* Z30-Z39 (Z3A) har med reproduksjonssprsmål o.l. 
	gen tmp1 = ( (regexm(hoved1, "O")) | (regexm(hoved1, "Z3")) )

	ge npr_nopreg = npr if tmp1!=1
	ge npr_nopreg_in = npr_in if tmp1!=1
	ge npr_nopreg_out = npr_out if tmp1!=1
	ge npr_nopreg_er = npr_er if tmp1!=1

	rename aar year
	rename liggetid npr_days

	gen main1 = substr(hoved1,1,1)
	*gen main2 = substr(hoved2,1,1)
	gen icd101 = substr(hoved1,1,3)
	*gen icd102 = substr(hoved2,1,3)

	gen main_o1 = substr(hoved1,1,3) if main1== "O"
	*gen main_o2 = substr(hoved2,1,3) if main2== "O"

	gen main_o1n = substr(hoved1,2,3) if main1== "O"
	*gen main_o2n = substr(hoved2,2,3) if main1== "O"
	*replace main_o2n = "" if main_o2n=="8n0" 
	destring main_o1n, replace
	replace main_o1n = int(main_o1n/10)
	*replace main_o2n = int(main_o2n/10)

	tempfile data
	save `data'

	charlson hoved1 if main1 != "O", index(10) idvar(lopenr) 
	merge 1:m lopenr using `data'

	ge npr_inf = main1 == "A" 
	ge npr_cancer = main1 == "C" | main1 == "D" 
	ge npr_endocr = main1 == "E" 
	ge npr_mental = main1 == "F"
	ge npr_nervous = main1 == "G" 
	ge npr_ear_eye = main1 == "H" 
	ge npr_heart = main1 == "I" 
	ge npr_resp = main1 == "J" 
	ge npr_disgest = main1 == "K" 
	ge npr_skin = main1 == "L"
	ge npr_muscle = main1 == "M" 
	ge npr_gen = main1 == "N"

	ge npr_obes = main1 == "O" 
	ge npr_preg_ab = (main1== "O" & main_o1n >= 0 & main_o1n <= 8) 
	ge npr_preg_mis = main1== "O" & main_o1n==3
	ge npr_preg_risk = (main1== "O" & main_o1n == 9) 
	ge npr_preg_comp = (main1== "O" & main_o1n >= 30 & main_o1n <= 48) 
	ge npr_preg_del = (main1== "O" & main_o1n >= 80 & main_o1n <= 84) 
	ge npr_preg_lab = (main1== "O" & main_o1n >= 85 & main_o1n <= 92)
	ge npr_preg_oth = npr_obes==1 & (npr_preg_comp!=1 & npr_preg_del!=1 & npr_preg_lab !=1)
	
	ge npr_normalpreg = main1== "Z" & main_o1n == 34
	ge npr_riskpreg = main1== "Z" & main_o1n == 35
	ge npr_antenatal = main1== "Z" & main_o1n == 36
	ge npr_birth = main1== "Z" & main_o1n == 37
	ge npr_postpartum = main1== "Z" & main_o1n == 39

	ge npr_cong = main1 == "Q" 
	ge npr_other = main1 == "S" | main1 == "T" | main1 == "V"  | main1 == "W" | main1 == "X" | main1 == "Y" 
	ge npr_injuries = main1 =="S" |main1 == "T"
	ge npr_accident = main1 =="V" |main1 == "W"
	ge npr_other_ext = main1 =="X"
	ge npr_rest = main1 == "R"  | main1 == "Z" 
	
	collapse (sum) npr* (mean) charlindex , by(lopenr)
	ge year = `num'
	save "npr`num'.dta", replace
}



foreach num of numlist  2015/2020 {
	use "S:/Project/DemoSos2/data2020/NPR/SOM/somatikk`num'.dta", clear
	replace aktivitetskategori3  = "" if aktivitetskategori3=="7gesund"
	destring _all, replace
	drop if lopenr == ""

	* Diagnoses:
	ge icd_l = substr(hoved1,1,1)
	drop hoved2
	*ge icd_l2 = substr(hoved2,1,1)
	*tab1 icd_l icd_l2
	replace icd_l = "" if icd_l == "9"
	*tab1 icd_l icd_l2

	tab  behandlingsniva3, m
	* Da blir outpatient kun poliklinikk
	gen admtype = 1 if aktivitetskategori3 == 1 | aktivitetskategori3 == 2
	replace admtype = 2 if aktivitetskategori3 == 3
	lab var admtype "1 = inpatient (døgn+dagbeh.); 2 = outpatient (poliklinikk)"

	*** Indikatorer for i registeret (at all/inpatient/outpatient)
	ge npr = 1
	* split scheduled adm in in- and outpatient groups
	ge npr_in = 1 if admtype == 1 & innmatehast == 2
	ge npr_out = 1 if admtype == 2 & innmatehast == 2
	* Emergency adm
	ge npr_er= 1 if innmatehast == 1

	*** Ekskluderer preg. related stuff
	* Alle O'er er svangerskap etc
	* Z30-Z39 (Z3A) har med reproduksjonssprsmål o.l. 
	gen tmp1 = ( (regexm(hoved1, "O")) | (regexm(hoved1, "Z3")) )

	ge npr_nopreg = npr if tmp1!=1
	ge npr_nopreg_in = npr_in if tmp1!=1
	ge npr_nopreg_out = npr_out if tmp1!=1
	ge npr_nopreg_er = npr_er if tmp1!=1

	rename aar year
	rename liggetid npr_days

	gen main1 = substr(hoved1,1,1)
	*gen main2 = substr(hoved2,1,1)
	gen icd101 = substr(hoved1,1,3)
	*gen icd102 = substr(hoved2,1,3)

	gen main_o1 = substr(hoved1,1,3) if main1== "O"
	*gen main_o2 = substr(hoved2,1,3) if main2== "O"

	gen main_o1n = substr(hoved1,2,3) if main1== "O"
	*gen main_o2n = substr(hoved2,2,3) if main1== "O"
	*replace main_o2n = "" if main_o2n=="8n0" 
	destring main_o1n, replace
	replace main_o1n = int(main_o1n/10)
	*replace main_o2n = int(main_o2n/10)

	tempfile data
	save `data'

	charlson hoved1 if main1 != "O", index(10) idvar(lopenr) 
	merge 1:m lopenr using `data'

	ge npr_inf = main1 == "A" 
	ge npr_cancer = main1 == "C" | main1 == "D" 
	ge npr_endocr = main1 == "E" 
	ge npr_mental = main1 == "F"
	ge npr_nervous = main1 == "G" 
	ge npr_ear_eye = main1 == "H" 
	ge npr_heart = main1 == "I" 
	ge npr_resp = main1 == "J" 
	ge npr_disgest = main1 == "K" 
	ge npr_skin = main1 == "L"
	ge npr_muscle = main1 == "M" 
	ge npr_gen = main1 == "N"

	ge npr_obes = main1 == "O" 
	ge npr_preg_ab = (main1== "O" & main_o1n >= 0 & main_o1n <= 8) 
	ge npr_preg_mis = main1== "O" & main_o1n==3
	ge npr_preg_risk = (main1== "O" & main_o1n == 9) 
	ge npr_preg_comp = (main1== "O" & main_o1n >= 30 & main_o1n <= 48) 
	ge npr_preg_del = (main1== "O" & main_o1n >= 80 & main_o1n <= 84) 
	ge npr_preg_lab = (main1== "O" & main_o1n >= 85 & main_o1n <= 92)
	ge npr_preg_oth = npr_obes==1 & (npr_preg_comp!=1 & npr_preg_del!=1 & npr_preg_lab !=1)
	
	ge npr_normalpreg = main1== "Z" & main_o1n == 34
	ge npr_riskpreg = main1== "Z" & main_o1n == 35
	ge npr_antenatal = main1== "Z" & main_o1n == 36
	ge npr_birth = main1== "Z" & main_o1n == 37
	ge npr_postpartum = main1== "Z" & main_o1n == 39

	ge npr_cong = main1 == "Q" 
	ge npr_other = main1 == "S" | main1 == "T" | main1 == "V"  | main1 == "W" | main1 == "X" | main1 == "Y" 
	ge npr_injuries = main1 =="S" |main1 == "T"
	ge npr_accident = main1 =="V" |main1 == "W"
	ge npr_other_ext = main1 =="X"
	ge npr_rest = main1 == "R"  | main1 == "Z" 
	

	collapse (sum) npr* (mean) charlindex , by(lopenr)
	ge year = `num'
	save "npr`num'.dta", replace
}


use "npr2008.dta", clear
for num 2009/2020: append using nprX
ge  npr_noer =  npr_out + npr_in
save health_npr, replace

* necessary vars npr only
use health_npr, clear
 keep npr_days npr npr_in npr_out npr_er npr_inf npr_cancer npr_endocr npr_mental npr_nervous npr_ear_eye npr_heart npr_resp ///
	npr_disgest npr_skin npr_muscle npr_gen npr_cong npr_other npr_injuries npr_accident npr_other_ext ///
	npr_intestinal npr_upperrespiratory npr_pneuflu npr_external npr_injury npr_poisoning npr_otherexternal ///
	npr_maltreatment npr_fracture npr_headinj npr_mhealthkid npr_internalising npr_externalising npr_badmood npr_anxiety npr_conduct npr_eatingdis npr_accidents lopenr year
ge npr_noer = npr_er ==0 
qui compress

save npr_sample, replace

*------------------------------------------------------------------------------*
** AVTALESPESIALISTER - PSYKISK HELSE **
*------------------------------------------------------------------------------*
use  "S:\Project\DemoSos2\data2020\NPR\AVTSP_PSYK\avtspes_psyk.dta", clear
drop if lopenr == ""

* Diagnoses:
ge icd_l = substr(hoved1,1,1)
ge icd_l2 = substr(hoved2,1,1)

ge asp_mental = icd_l =="F"|icd_l2 == "F"
* Antall bitilstander
tab bitil // 93% har null bitilstander
drop bitil

gen asp_psyk = 1
rename aar year

collapse (sum) asp*, by(lopenr year)
save "psyk.dta", replace

*------------------------------------------------------------------------------*
* specialist care**
*------------------------------------------------------------------------------*
use "S:\Project\DemoSos2\data2020\NPR\AVTSP_SOM\avtspes_som.dta", clear
drop if lopenr == ""

* Diagnoses:
ge main1 = substr(hoved1,1,1)
ge main2 = substr(hoved2,1,1)

ge som_inf = main1 == "A" | main2 == "A"
ge som_cancer = main1 == "C" | main1 == "D" |  main2 == "C" | main2 == "D"
ge som_endocr = main1 == "E" | main2 == "E"
ge som_mental = main1 == "F" | main2 == "F"
ge som_nervous = main1 == "G" | main2 == "G"
ge som_ear_eye = main1 == "H" | main2 == "H"
ge som_heart = main1 == "I" | main2 == "I"
ge som_resp = main1 == "J" | main2 == "J"
ge som_disgest = main1 == "K" | main2 == "K"
ge som_skin = main1 == "L" | main2 == "L"
ge som_muscle = main1 == "M" | main2 == "M"
ge som_gen = main1 == "N" | main2 == "N"

ge som_obes = main1 == "O" | main2 == "O"

ge som_cong = main1 == "Q" | main2 == "Q"
ge som_other = main1 == "S" | main2 == "S" | main1 == "T" | main2 == "T" | main1 == "V" | main2 == "V" | main1 == "W" | main2 == "W" | main1 == "X" | main2 == "X" | main1 == "Y" | main2 == "Y"
ge som_injuries = main1 =="S"|main2 == "S"|main1 == "T"|main2 == "T"
ge som_accident = main1 =="V"|main2 == "V"|main1 == "W"|main2 == "W"
ge som_other_ext = main1 =="X"
ge som_rest = main1 == "R" | main2 == "R" | main1 == "Z" | main2 == "Z"
	
ge som =1
rename aar year
collapse (sum) som*, by(lopenr year)
save "som.dta", replace

*------------------------------------------------------------------------------*
															** REHABILITERING **
*------------------------------------------------------------------------------*
use "S:\Project\DemoSos2\data2020\NPR\TSB\rus_beh.dta", clear
drop if lopenr == ""

* Diagnoses:
ge icd_l = substr(hoved1, 1,1)
ge icd_l2 = substr(hoved2, 1,1)
replace icd_l = "E" if icd_l =="e" 
replace icd_l = "F" if icd_l =="f" 
replace icd_l = "G" if icd_l =="g" 
replace icd_l = "I" if icd_l =="i" 
replace icd_l = "J" if icd_l =="j" 
replace icd_l = "K" if icd_l =="k" 
replace icd_l = "L" if icd_l =="l" 
replace icd_l = "M" if icd_l =="m" 
replace icd_l = "N" if icd_l =="n" 
replace icd_l = "Q" if icd_l =="q" 
replace icd_l = "R" if icd_l =="r" 
replace icd_l = "S" if icd_l =="s" 
replace icd_l = "T" if icd_l =="t" 
replace icd_l = "Z" if icd_l =="z" 

tab icd_l // 83% F (psych)

ge npr_mental_rehab = 1 if (icd_l=="F"|icd_l2=="F")

* Dummy = 1 if in this register
ge npr_rehab = 1

rename aar year
keep lopenr year npr* 
collapse (sum) npr*, by(lopenr year)
save "npr_rehab.dta", replace



*------------------------------------------------------------------------------*
															** psyk **
*------------------------------------------------------------------------------*
use "S:\Project\DemoSos2\data2020\NPR\PSYK_V\psyk_voksne.dta" , clear
drop if lopenr == ""

* Diagnoses:
ge icd_l = substr(hoved1, 1,1)
ge icd_l2 = substr(hoved2, 1,1)
replace icd_l = "E" if icd_l =="e" 
replace icd_l = "F" if icd_l =="f" 
replace icd_l = "G" if icd_l =="g" 
replace icd_l = "I" if icd_l =="i" 
replace icd_l = "J" if icd_l =="j" 
replace icd_l = "K" if icd_l =="k" 
replace icd_l = "L" if icd_l =="l" 
replace icd_l = "M" if icd_l =="m" 
replace icd_l = "N" if icd_l =="n" 
replace icd_l = "Q" if icd_l =="q" 
replace icd_l = "R" if icd_l =="r" 
replace icd_l = "S" if icd_l =="s" 
replace icd_l = "T" if icd_l =="t" 
replace icd_l = "Z" if icd_l =="z" 

ge psyk_v= 1 
rename aar year
collapse (sum) psyk_v, by(lopenr year)
save "bup.dta", replace

