*----------------------------------------------------------------------------
* DATA PREPARATION
*----------------------------------------------------------------------------
* clean up health data
do clean_health.do
do clean_npr.do
do clean_health_kids.do // Figures A1 and A2

* other cleaning
do middleschools.do
do gpids.do

* prepares relavant sample, SL (NAV) data and education
do sample_prep.do

* create family links
do with_sample_restrictions2/1_ggp_gp_p_psibs.do
do with_sample_restrictions2/2_pcousins.do
do with_sample_restrictions2/3_spouses.do
do with_sample_restrictions2/4_siblings_of_spouses.do

* aux files to merge health/education of relatives in each generation (and age group)
do close.do
do mor_cousin.do
do mor_cousin_sp.do
do far_cousin.do
do far_cousin_sp.do
do mor_sib_sp_sib.do
do far_sib_sp_sib.do
do close3035.do
do mor_cousin_3035.do
do mor_cousin_sp_3035.do
do far_cousin_3035.do
do far_cousin_sp_3035.do
do mor_sib_sp_sib_3035.do
do far_sib_sp_sib_3035.do

* put samples together
do merge25_30.do /// parents/relatives at 25-30 (also education for relatives, occupation of relatives and mortality of grandparents)
do merge30_35.do /// parents/relatives at 30-35
do merge25_30_age6.do /// parents/relatives at 25-30 (kids ages 6-18)
do merge30_35_age6.do /// parents/relatives at 30-35 (kids ages 6-18)

*----------------------------------------------------------------------------
* ANALYSIS
*----------------------------------------------------------------------------
* ig part
do interg_reg.do // Tables 2, 3 (Table 3 clustered by family, for report), 4, 5, 6, 7 (cols 1-7), 8 (cols 1-7), A3, A4, A5, A6 A7, A10, A11, A15, A16, A17
do interg_reg3035.do // Tables 7 and 8 (col 8)
do interg_reg6.do // Table A13
do interg_reg3035_6.do // Table A14
do measurement_error.do // Table A8
do missing_parents.do // Table A9
do corr.do // Table A12

* policy part
do pol_reg.do // Tables 9, A18, A19, Figs1, A3

