clear all
capture clear
capture log close
capture program drop _all
set maxvar 100000
set max_memory 120g
cd "O:\mentalhealth\data\"
set more off


*-------------------------------------------------------------------------
//merge with the focal children sample
*-------------------------------------------------------------------------
use lopenr age_c if age_c >= 6 & age_c<= 18 using sample_new3, clear
drop age_c
duplicates drop
* merge health and educ of family members
merge 1:1 lopenr using sample_with_dyn_idsclose_3035, keep(3) nogen
merge 1:1 lopenr using sample_with_dyn_idsmor_cousins_3035, keep(3) nogen
merge 1:1 lopenr using sample_with_dyn_idsfar_cousins_3035, keep(3) nogen
merge 1:1 lopenr using sample_with_dyn_idsmor_cousins_sp_3035, keep(3) nogen
merge 1:1 lopenr using sample_with_dyn_idsfar_cousins_sp_3035, keep(3) nogen
merge 1:1 lopenr using sample_with_dyn_idsmor_sibspsib_3035, keep(3) nogen
merge 1:1 lopenr using sample_with_dyn_idsfar_sibspsib_3035, keep(3) nogen
qui compress


* health of parents, uncles/aunts, their spouses, their spouses' siblings
foreach k in 30 {
	local v = `k'+5
	
	foreach var in mor far {		
		egen MH`var'_sibs_i`k'`v' = rmean(`var'_sib*_lnrMH_i`k'`v')
		egen MH`var'_sibs_e`k'`v' = rmax(`var'_sib*_lnrMH_e`k'`v')
		egen OH`var'_sibs_i`k'`v' = rmean(`var'_sib*_lnrOH_i`k'`v')
		egen OH`var'_sibs_e`k'`v' = rmax(`var'_sib*_lnrOH_e`k'`v')
		egen SL`var'_sibs_i`k'`v' = rmean(`var'_sib*_lnrSL_i`k'`v')
		egen SL`var'_sibs_e`k'`v' = rmax(`var'_sib*_lnrSL_e`k'`v')
		
		egen MH`var'_sibsp_i`k'`v' = rmean(`var'_sib*_lnr_spouseMH_i`k'`v')
		egen MH`var'_sibsp_e`k'`v' = rmax(`var'_sib*_lnr_spouseMH_e`k'`v')
		egen OH`var'_sibsp_i`k'`v' = rmean(`var'_sib*_lnr_spouseOH_i`k'`v')
		egen OH`var'_sibsp_e`k'`v' = rmax(`var'_sib*_lnr_spouseOH_e`k'`v')
		egen SL`var'_sibsp_i`k'`v' = rmean(`var'_sib*_lnr_spouseSL_i`k'`v')
		egen SL`var'_sibsp_e`k'`v' = rmax(`var'_sib*_lnr_spouseSL_e`k'`v')
		
		egen MH`var'_cous_i`k'`v' = rmean(`var'_cous*_lnrMH_i`k'`v')
		egen MH`var'_cous_e`k'`v' = rmax(`var'_cous*_lnrMH_e`k'`v')
		egen OH`var'_cous_i`k'`v' = rmean(`var'_cous*_lnrOH_i`k'`v')
		egen OH`var'_cous_e`k'`v' = rmax(`var'_cous*_lnrOH_e`k'`v')
		egen SL`var'_cous_i`k'`v' = rmean(`var'_cous*_lnrSL_i`k'`v')
		egen SL`var'_cous_e`k'`v' = rmax(`var'_cous*_lnrSL_e`k'`v')
		
		egen MH`var'_cousp_i`k'`v' = rmean(`var'_cous*_lnr_spouseMH_i`k'`v')
		egen MH`var'_cousp_e`k'`v' = rmax(`var'_cous*_lnr_spouseMH_e`k'`v')
		egen OH`var'_cousp_i`k'`v' = rmean(`var'_cous*_lnr_spouseOH_i`k'`v')
		egen OH`var'_cousp_e`k'`v' = rmax(`var'_cous*_lnr_spouseOH_e`k'`v')
		egen SL`var'_cousp_i`k'`v' = rmean(`var'_cous*_lnr_spouseSL_i`k'`v')
		egen SL`var'_cousp_e`k'`v' = rmax(`var'_cous*_lnr_spouseSL_e`k'`v')
		
		egen MH`var'_sib_sp_sib_i`k'`v' = rmean(`var'_sib*_sp_sib*MH_i`k'`v')
		egen MH`var'_sib_sp_sib_e`k'`v' = rmax(`var'_sib*_sp_sib*MH_e`k'`v')
		egen OH`var'_sib_sp_sib_i`k'`v' = rmean(`var'_sib*_sp_sib*OH_i`k'`v')
		egen OH`var'_sib_sp_sib_e`k'`v' = rmax(`var'_sib*_sp_sib*OH_e`k'`v')
		egen SL`var'_sib_sp_sib_i`k'`v' = rmean(`var'_sib*_sp_sib*SL_i`k'`v')
		egen SL`var'_sib_sp_sib_e`k'`v' = rmax(`var'_sib*_sp_sib*SL_e`k'`v')
		
		foreach diag in mus muf muo can chr car dep anx sub adh eat op  {
			egen `diag'`var'_sibs_e`k'`v' = rmax(`var'_sib*_lnr`diag'e`k'`v')
			egen `diag'`var'_sibsp_e`k'`v' = rmax(`var'_sib*_lnr_spouse`diag'e`k'`v')
			egen `diag'`var'_cous_e`k'`v' = rmax(`var'_cous*_lnr`diag'e`k'`v')
			egen `diag'`var'_cousp_e`k'`v' = rmax(`var'_cous*_lnr_spouse`diag'e`k'`v')
			egen `diag'`var'_sib_sp_sib_e`k'`v' = rmax(`var'_sib*_sp_sib*`diag'e`k'`v')
			
			drop `var'_sib*_lnr`diag'e`k'`v' `var'_sib*_lnr_spouse`diag'e`k'`v' `var'_cous*_lnr`diag'e`k'`v' `var'_cous*_lnr_spouse`diag'e`k'`v' `var'_sib*_sp_sib*`diag'e`k'`v'		
		}
		
		
		drop `var'_sib*_lnrMH_i`k'`v' `var'_sib*_lnrMH_e`k'`v' `var'_sib*_lnrOH_i`k'`v' `var'_sib*_lnrOH_e`k'`v' ///
			`var'_sib*_lnrSL_i`k'`v' `var'_sib*_lnrSL_e`k'`v' ///
			`var'_sib*_lnr_spouseMH_i`k'`v' `var'_sib*_lnr_spouseMH_e`k'`v' `var'_sib*_lnr_spouseOH_i`k'`v' ///
			`var'_sib*_lnr_spouseOH_e`k'`v' `var'_sib*_lnr_spouseSL_i`k'`v' `var'_sib*_lnr_spouseSL_e`k'`v' ///
			`var'_cous*_lnrMH_i`k'`v' `var'_cous*_lnrMH_e`k'`v' `var'_cous*_lnrOH_i`k'`v' `var'_cous*_lnrOH_e`k'`v' ///
			`var'_cous*_lnrSL_i`k'`v' `var'_cous*_lnrSL_e`k'`v' ///
			`var'_cous*_lnr_spouseMH_i`k'`v' `var'_cous*_lnr_spouseMH_e`k'`v' `var'_cous*_lnr_spouseOH_i`k'`v' ///
			`var'_cous*_lnr_spouseOH_e`k'`v' `var'_cous*_lnr_spouseSL_i`k'`v' `var'_cous*_lnr_spouseSL_e`k'`v' ///
			`var'_sib*_sp_sib*MH_i`k'`v' `var'_sib*_sp_sib*MH_e`k'`v' `var'_sib*_sp_sib*OH_i`k'`v' `var'_sib*_sp_sib*OH_e`k'`v' `var'_sib*_sp_sib*SL_i`k'`v' `var'_sib*_sp_sib*SL_e`k'`v'
	}

	foreach type in MH OH SL {
		egen  `type'_i`k'`v' = rmean(mor_lnr`type'_i`k'`v' far_lnr`type'_i`k'`v') 
		replace  `type'_i`k'`v' = . if mor_lnr`type'_i`k'`v' == . & far_lnr`type'_i`k'`v' == .
		egen  `type'_e`k'`v' = rmax(mor_lnr`type'_e`k'`v' far_lnr`type'_e`k'`v') 
		replace  `type'_e`k'`v' = . if mor_lnr`type'_e`k'`v' == . & far_lnr`type'_e`k'`v' == .
		
		egen  `type'_sibs_i`k'`v' = rmean(`type'mor_sibs_i`k'`v' `type'far_sibs_i`k'`v')
		egen  `type'_sibs_e`k'`v' = rmax(`type'mor_sibs_e`k'`v' `type'far_sibs_e`k'`v') 	
		
		egen  `type'_sibsp_i`k'`v' = rmean(`type'mor_sibsp_i`k'`v' `type'far_sibsp_i`k'`v')
		egen  `type'_sibsp_e`k'`v' = rmax(`type'mor_sibsp_e`k'`v' `type'far_sibsp_e`k'`v') 	

		egen  `type'_cous_i`k'`v' = rmean(`type'mor_cous_i`k'`v' `type'far_cous_i`k'`v')
		egen  `type'_cous_e`k'`v' = rmax(`type'mor_cous_e`k'`v' `type'far_cous_e`k'`v') 	
		
		egen  `type'_cousp_i`k'`v' = rmean(`type'mor_cousp_i`k'`v' `type'far_cousp_i`k'`v')
		egen  `type'_cousp_e`k'`v' = rmax(`type'mor_cousp_e`k'`v' `type'far_cousp_e`k'`v') 	
		
		egen  `type'_sib_sp_sib_i`k'`v' = rmean(`type'mor_sib_sp_sib_i`k'`v' `type'far_sib_sp_sib_i`k'`v')
		egen  `type'_sib_sp_sib_e`k'`v' = rmax(`type'mor_sib_sp_sib_e`k'`v' `type'far_sib_sp_sib_e`k'`v')	
		
	}
	
	foreach type in mus muf muo can chr car dep anx sub adh eat op  {
		egen  `type'_e`k'`v' = rmax(mor_lnr`type'e`k'`v' far_lnr`type'e`k'`v') 
		replace  `type'_e`k'`v' = . if mor_lnr`type'e`k'`v' == . & far_lnr`type'e`k'`v' == .
		
		egen  `type'_sibs_e`k'`v' = rmax(`type'mor_sibs_e`k'`v' `type'far_sibs_e`k'`v') 		
		egen  `type'_sibsp_e`k'`v' = rmax(`type'mor_sibsp_e`k'`v' `type'far_sibsp_e`k'`v') 	
		egen  `type'_cous_e`k'`v' = rmax(`type'mor_cous_e`k'`v' `type'far_cous_e`k'`v') 	
		egen  `type'_cousp_e`k'`v' = rmax(`type'mor_cousp_e`k'`v' `type'far_cousp_e`k'`v') 	
		egen  `type'_sib_sp_sib_e`k'`v' = rmax(`type'mor_sib_sp_sib_e`k'`v' `type'far_sib_sp_sib_e`k'`v')	
	}
	
	label var mor_lnrMH_i`k'`v' "Mother's MH `k'-`v' - int"
	label var far_lnrMH_i`k'`v' "Father's MH `k'-`v' - int"
	label var mor_lnrMH_e`k'`v' "Mother's MH `k'-`v' - ext"
	label var far_lnrMH_e`k'`v' "Father's MH `k'-`v' - ext"
	label var mor_lnrOH_i`k'`v' "Mother's OH `k'-`v' - int"
	label var far_lnrOH_i`k'`v' "Father's OH `k'-`v' - int"
	label var mor_lnrOH_e`k'`v' "Mother's OH `k'-`v' - ext"
	label var far_lnrOH_e`k'`v' "Father's OH `k'-`v' - ext"
	label var mor_lnrSL_i`k'`v' "Mother's SL `k'-`v' - int"
	label var far_lnrSL_i`k'`v' "Father's SL `k'-`v' - int"
	label var mor_lnrSL_e`k'`v' "Mother's SL `k'-`v' - ext"
	label var far_lnrSL_e`k'`v' "Father's SL `k'-`v' - ext"
	
	label var MHmor_sibs_i`k'`v' "Mother's Siblings MH `k'-`v' - int" 
	label var MHfar_sibs_i`k'`v' "Father's Siblings MH `k'-`v' - int"
	label var MHmor_sibs_e`k'`v' "Mother's Siblings MH `k'-`v' - ext" 
	label var MHfar_sibs_e`k'`v' "Father's Siblings MH `k'-`v' - ext" 
	label var OHmor_sibs_i`k'`v' "Mother's Siblings OH `k'-`v' - int" 
	label var OHfar_sibs_i`k'`v' "Father's Siblings OH `k'-`v' - int"
	label var OHmor_sibs_e`k'`v' "Mother's Siblings OH `k'-`v' - ext" 
	label var OHfar_sibs_e`k'`v' "Father's Siblings OH `k'-`v' - ext" 
	label var SLmor_sibs_i`k'`v' "Mother's Siblings SL `k'-`v' - int" 
	label var SLfar_sibs_i`k'`v' "Father's Siblings SL `k'-`v' - int" 
	label var SLmor_sibs_e`k'`v' "Mother's Siblings SL `k'-`v' - ext" 
	label var SLfar_sibs_e`k'`v' "Father's Siblings SL `k'-`v' - ext" 

	label var MHmor_sibsp_i`k'`v' "Mother Siblings' Spouse MH `k'-`v' - int" 
	label var MHfar_sibsp_i`k'`v' "Father Siblings' Spouse MH `k'-`v' - int"
	label var MHmor_sibsp_e`k'`v' "Mother Siblings' Spouse MH `k'-`v' - ext" 
	label var MHfar_sibsp_e`k'`v' "Father Siblings' Spouse MH `k'-`v' - ext"  
	label var OHmor_sibsp_i`k'`v' "Mother Siblings' Spouse OH `k'-`v' - int" 
	label var OHfar_sibsp_i`k'`v' "Father Siblings' Spouse OH `k'-`v' - int"
	label var OHmor_sibsp_e`k'`v' "Mother Siblings' Spouse OH `k'-`v' - ext" 
	label var OHfar_sibsp_e`k'`v' "Father Siblings' Spouse OH `k'-`v' - ext"  
	label var SLmor_sibsp_i`k'`v' "Mother Siblings' Spouse SL `k'-`v' - int" 
	label var SLfar_sibsp_i`k'`v' "Father Siblings' Spouse SL `k'-`v' - int" 
	label var SLmor_sibsp_e`k'`v' "Mother Siblings' Spouse SL `k'-`v' - ext" 
	label var SLfar_sibsp_e`k'`v' "Father Siblings' Spouse SL `k'-`v' - ext"
	
	label var MHmor_cous_i`k'`v' "Mother's Cousins MH `k'-`v' - int" 
	label var MHfar_cous_i`k'`v' "Father's Cousins MH `k'-`v' - int"
	label var MHmor_cous_e`k'`v' "Mother's Cousins MH `k'-`v' - ext" 
	label var MHfar_cous_e`k'`v' "Father's Cousins MH `k'-`v' - ext" 
	label var OHmor_cous_i`k'`v' "Mother's Cousins OH `k'-`v' - int" 
	label var OHfar_cous_i`k'`v' "Father's Cousins OH `k'-`v' - int"
	label var OHmor_cous_e`k'`v' "Mother's Cousins OH `k'-`v' - ext" 
	label var OHfar_cous_e`k'`v' "Father's Cousins OH `k'-`v' - ext" 
	label var SLmor_cous_i`k'`v' "Mother's Cousins SL `k'-`v' - int" 
	label var SLfar_cous_i`k'`v' "Father's Cousins SL `k'-`v' - int" 
	label var SLmor_cous_e`k'`v' "Mother's Cousins SL `k'-`v' - ext" 
	label var SLfar_cous_e`k'`v' "Father's Cousins SL `k'-`v' - ext" 

	label var MHmor_cousp_i`k'`v' "Mother Cousins' Spouse MH `k'-`v' - int" 
	label var MHfar_cousp_i`k'`v' "Father Cousins' Spouse MH `k'-`v' - int"
	label var MHmor_cousp_e`k'`v' "Mother Cousins' Spouse MH `k'-`v' - ext" 
	label var MHfar_cousp_e`k'`v' "Father Cousins' Spouse MH `k'-`v' - ext"  
	label var OHmor_cousp_i`k'`v' "Mother Cousins' Spouse OH `k'-`v' - int" 
	label var OHfar_cousp_i`k'`v' "Father Cousins' Spouse OH `k'-`v' - int"
	label var OHmor_cousp_e`k'`v' "Mother Cousins' Spouse OH `k'-`v' - ext" 
	label var OHfar_cousp_e`k'`v' "Father Cousins' Spouse OH `k'-`v' - ext"  
	label var SLmor_cousp_i`k'`v' "Mother Cousins' Spouse SL `k'-`v' - int" 
	label var SLfar_cousp_i`k'`v' "Father Cousins' Spouse SL `k'-`v' - int" 
	label var SLmor_cousp_e`k'`v' "Mother Cousins' Spouse SL `k'-`v' - ext" 
	label var SLfar_cousp_e`k'`v' "Father Cousins' Spouse SL `k'-`v' - ext"
	
	label var MHmor_sib_sp_sib_i`k'`v' "Siblings of spouses of mother's siblings MH `k'-`v' - int" 
	label var MHfar_sib_sp_sib_i`k'`v' "Siblings of spouses of father's siblings MH `k'-`v' - int" 
	label var MHmor_sib_sp_sib_e`k'`v' "Siblings of spouses of mother's siblings MH `k'-`v' - ext" 
	label var MHfar_sib_sp_sib_e`k'`v' "Siblings of spouses of father's siblings MH `k'-`v' - ext" 
	label var OHmor_sib_sp_sib_i`k'`v' "Siblings of spouses of mother's siblings OH `k'-`v' - int" 
	label var OHfar_sib_sp_sib_i`k'`v' "Siblings of spouses of father's siblings OH `k'-`v' - int" 
	label var OHmor_sib_sp_sib_e`k'`v' "Siblings of spouses of mother's siblings OH `k'-`v' - ext" 
	label var OHfar_sib_sp_sib_e`k'`v' "Siblings of spouses of father's siblings OH `k'-`v' - ext" 	
	label var SLmor_sib_sp_sib_i`k'`v' "Siblings of spouses of mother's siblings SL `k'-`v' - int" 
	label var SLfar_sib_sp_sib_i`k'`v' "Siblings of spouses of father's siblings SL `k'-`v' - int" 
	label var SLmor_sib_sp_sib_e`k'`v' "Siblings of spouses of mother's siblings SL `k'-`v' - ext" 
	label var SLfar_sib_sp_sib_e`k'`v' "Siblings of spouses of father's siblings SL `k'-`v' - ext" 
	
	label var MH_i`k'`v' "Parent's MH `k'-`v' - int" 
	label var MH_e`k'`v' "Parent's MH `k'-`v' - ext" 
	label var OH_i`k'`v' "Parent's OH `k'-`v' - int" 
	label var OH_e`k'`v' "Parent's OH `k'-`v' - ext" 
	label var SL_i`k'`v' "Parent's SL `k'-`v' - int" 
	label var SL_e`k'`v' "Parent's SL `k'-`v' - ext" 
	
	label var MH_sibs_i`k'`v' "Parent's Siblings MH `k'-`v' - int" 
	label var MH_sibs_e`k'`v' "Parent's Siblings MH `k'-`v' - ext" 
	label var OH_sibs_i`k'`v' "Parent's Siblings OH `k'-`v' - int" 
	label var OH_sibs_e`k'`v' "Parent's Siblings OH `k'-`v' - ext" 
	label var SL_sibs_i`k'`v' "Parent's Siblings SL `k'-`v' - int" 
	label var SL_sibs_e`k'`v' "Parent's Siblings SL `k'-`v' - ext" 
	
	label var MH_sibsp_i`k'`v' "Parent Siblings' Spouse MH `k'-`v' - int" 
	label var MH_sibsp_e`k'`v' "Parent Siblings' Spouse MH `k'-`v' - ext" 
	label var OH_sibsp_i`k'`v' "Parent Siblings' Spouse OH `k'-`v' - int" 
	label var OH_sibsp_e`k'`v' "Parent Siblings' Spouse OH `k'-`v' - ext" 
	label var SL_sibsp_i`k'`v' "Parent Siblings' Spouse SL `k'-`v' - int" 
	label var SL_sibsp_e`k'`v' "Parent Siblings' Spouse SL `k'-`v' - ext" 

	label var MH_cous_i`k'`v' "Parent's Cousins MH `k'-`v' - int" 
	label var MH_cous_e`k'`v' "Parent's Cousins MH `k'-`v' - ext" 
	label var OH_cous_i`k'`v' "Parent's Cousins OH `k'-`v' - int" 
	label var OH_cous_e`k'`v' "Parent's Cousins OH `k'-`v' - ext" 
	label var SL_cous_i`k'`v' "Parent's Cousins SL `k'-`v' - int" 
	label var SL_cous_e`k'`v' "Parent's Cousins SL `k'-`v' - ext" 
	
	label var MH_cousp_i`k'`v' "Parent Cousins' Spouse MH `k'-`v' - int" 
	label var MH_cousp_e`k'`v' "Parent Cousins' Spouse MH `k'-`v' - ext" 
	label var OH_cousp_i`k'`v' "Parent Cousins' Spouse OH `k'-`v' - int" 
	label var OH_cousp_e`k'`v' "Parent Cousins' Spouse OH `k'-`v' - ext" 
	label var SL_cousp_i`k'`v' "Parent Cousins' Spouse SL `k'-`v' - int" 
	label var SL_cousp_e`k'`v' "Parent Cousins' Spouse SL `k'-`v' - ext" 
	
	label var MH_sib_sp_sib_i`k'`v' "Sibling of spouses of parents' siblings MH `k'-`v' - int"
	label var MH_sib_sp_sib_e`k'`v' "Sibling of spouses of parents' siblings MH `k'-`v' - ext"
	label var OH_sib_sp_sib_i`k'`v' "Sibling of spouses of parents' siblings OH `k'-`v' - int"
	label var OH_sib_sp_sib_e`k'`v' "Sibling of spouses of parents' siblings OH `k'-`v' - ext"
	label var SL_sib_sp_sib_i`k'`v' "Sibling of spouses of parents' siblings SL `k'-`v' - int"
	label var SL_sib_sp_sib_e`k'`v' "Sibling of spouses of parents' siblings SL `k'-`v' - ext"
}

foreach k in 30 {
local v = `k'+5
	foreach var in mor far {	
		foreach diag in mus muf muo can chr car dep anx sub adh eat op  {
			drop `var'_sib*_lnr`diag'i`k'`v' `var'_sib*_lnr_spouse`diag'i`k'`v' `var'_cous*_lnr`diag'i`k'`v' `var'_cous*_lnr_spouse`diag'i`k'`v' `var'_sib*_sp_sib*`diag'i`k'`v'		
		}
	}
}

save parental_gen6_3035, replace


*-------------------------------------------------------------------------
//merge with the focal children sample
*-------------------------------------------------------------------------
use if age_c >= 6 & age_c<= 18 using sample_new3, clear


* health of children
ge sec_mental = npr_mental + asp_mental + asp_psyk
ge dsec_mental = sec_mental >0 if year>=2008 & year <= 2020
ge dnpr = npr >0 if year>=2008 & year <= 2020
local i= 6
local j= 18
foreach var in total gp er simple_contact consult blood_test labtest depression anxiety substance adhd eating other_psy diag_P non_psy ///
	diag_A diag_B diag_D diag_E diag_F diag_H diag_K diag_L diag_N diag_R diag_S diag_T diag_U ///
	asthma_allergies fractures dep_anx npr sec_mental  {
	ge aux = d`var' if age_c >= `i' & age_c<=`j'
	bys lopenr: egen c`var' = max(aux)
	replace c`var'=c`var'*100
	drop aux
	
	ge aux = `var' if age_c >= `i' & age_c<=`j'
	bys lopenr: egen s`var' = sum(aux)
	drop aux
}

drop npr_days npr npr_in npr_out npr_er npr_inf npr_cancer npr_endocr npr_mental npr_nervous npr_ear_eye npr_heart npr_resp ///
	npr_disgest npr_skin npr_muscle npr_gen npr_cong npr_other npr_injuries npr_accident npr_other_ext ///
	npr_intestinal npr_upperrespiratory npr_pneuflu npr_external npr_injury npr_poisoning  ///
	npr_maltreatment npr_fracture npr_headinj npr_mhealthkid npr_internalising npr_externalising npr_badmood npr_anxiety npr_conduct npr_eatingdis npr_accidents 


ge male = sex=="1" if sex!=""

* sample restrictions
bys lopenr (year): ge n = _n
keep if n == 1
keep if bokomm!=.
qui compress

* parental educ
foreach j in m f {	
	tostring eduy_`j', replace
	ge bu_1`j' = substr(eduy_`j',1,1)
	destring bu_1`j', replace
}

ge college_par = inlist(bu_1m, 6, 7, 8) | inlist(bu_1f, 6, 7, 8)
ge college_mor = inlist(bu_1m, 6, 7, 8) 
ge college_far = inlist(bu_1f, 6, 7, 8)
	
* years of edu
foreach par in m f {
	ge `par'_eduy = 0 if bu_1`par' ==0 
	replace `par'_eduy = 7 if bu_1`par' ==1 
	replace `par'_eduy = 10 if bu_1`par' ==2
	replace `par'_eduy = 12 if bu_1`par' ==3
	replace `par'_eduy = 13 if bu_1`par' ==4
	replace `par'_eduy = 14 if bu_1`par' ==5
	replace `par'_eduy = 17 if bu_1`par' ==6
	replace `par'_eduy = 19 if bu_1`par' ==7
	replace `par'_eduy = 20 if bu_1`par' ==8
	replace `par'_eduy = . if bu_1`par' ==9
}	


merge 1:1 lopenr using parental_gen6_3035
keep if _m==3
drop _m
compress

*members in each branch
merge 1:1 lopenr using "working_sample_children", keep(3) nogen keepusing(mor_sib*_sp_sib far_sib*_sp_sib)

foreach j in mor far {
	ge `j'_nsibs = 0
	ge `j'_nb_sp = 0
	ge `j'_ncous = 0
	ge `j'_ncousp = 0
	ge `j'_sib_sp_sib = 0
	foreach i of numlist 1/17 {
		replace `j'_nsibs = `j'_nsibs + 1 if `j'_sib`i'_lnr !=""
		replace `j'_nb_sp = `j'_nb_sp + 1 if `j'_sib`i'_lnr_spouse !=""
		replace `j'_ncous = `j'_ncous + 1 if `j'_cous`i'_lnr != ""
		replace `j'_ncousp = `j'_ncousp + 1 if `j'_cous`i'_lnr_spouse != ""
		replace `j'_sib_sp_sib = `j'_sib_sp_sib + 1 if `j'_sib`i'_sp_sib != "" 
	}
}

merge 1:1 lopenr using  middleschool
keep if _m!=2
drop _m
egen middleschool_d = group(middleschool)
compress
save sample_final_x3035_age6, replace


